
#define uu unsigned
#define WHOOSH_REG

void enlargement_look( 
		uu char * const dr , 
		const uu int 	 sw , 
		const uu char * const sr ,
		const int 	 cyberfactor ,
		const uu int * const look 
			) ;
void enlargement_look( 
		uu char * const dr , 
		const uu int 	 sw , 
		const uu char * const sr ,
		const int 	 cyberfactor ,
		const uu int * const look 
			)
{
uu short * const dr2 = (void *)dr ;
uu int * const dr4 = (void *)dr ;
const uu short * const sr2 = (void *)sr ;
const uu int * const sr4 = (void *)sr ;

#define		enlarge_look(dr0, sr0, look0 )		\
	{						\
	uu int x , X , X1 , i ; uu int c ;		\
							\
	for( x = 0 , X = 0 ; x < sw ; x++ )		\
		{					\
		c = sr0[ x ] ; X1 = look0[ x ] ;	\
		while( X < X1 )dr0[ X++ ] = c ;		\
		}					\
	}

switch( cyberfactor )
	{
	case 1 : enlarge_look( dr, sr, look ) ; break ;
	case 2 : enlarge_look( dr2, sr2, look ) ; break ;
	case 4 : enlarge_look( dr4, sr4, look ) ; break ;
	default:
		{
		uu int x , xx , X , XX , X1 , i ;
		for( x = 0 , xx = 0 , X = 0 , XX = 0 ; x < sw ; x++ , xx += cyberfactor )
			{
			X1 = look[ x ] ;
			for( ; X < X1 ; X++ )
				{
				/* reusing xx repeatedly so dont do xx++ */
				for( i = 0 ; i < cyberfactor ; i++ )
					dr[ XX++ ] = sr[ xx + i ] ;
				}
			}
		}
	break ;
	}
}



void reduction_look( 
		uu char * const dr , 
		const WHOOSH_REG uu int   dw , 
		const uu char * const sr , 
		const int      cyberfactor ,
		const WHOOSH_REG uu int * const look )
{
uu short * const dr2 = (void *)dr ;
WHOOSH_REG uu int   * const dr4 = (void *)dr ;
const uu short * const sr2 = (void *)sr ;
const WHOOSH_REG uu int   * const sr4 = (void *)sr ;

#define reduction_look_( DR , SR )			\
	{						\
	WHOOSH_REG uu int X ;				\
	for( X = 0 ; X < dw ; X++ )			\
		{					\
		DR[ X ] = SR[ look[ X ] ] ;		\
		}					\
	}

switch( cyberfactor )
	{
	case 1 : reduction_look_( dr , sr ) ; break ;
	case 2 : reduction_look_( dr2 , sr2 ) ; break ;
	case 4 : reduction_look_( dr4 , sr4 ) ; break ;
	default:
		{
		uu int C = 0 , c = 0 , X = 0 ; int i ;
		for( ; X < dw ; X++ )
			{
			c = look[ X ] ;
			for( i = 0 ; i < cyberfactor ; i++ )dr[ C++ ] = sr[ c+i ] ;
			}
		}
	break ;
	}
}


